#define	LOG_HEADER_0 "<html><head><title>Result of compilating file: "
#define LOG_HEADER_1 "</title></head><body>"
#define LOG_BODY_END "</body></html>"

void	yyerror(const char *format, ...);
extern int	line_number;

//****************************************************************************************************************
//Trida Log pro logovani zprav do konzole a do logovaciho souboru
//****************************************************************************************************************
class	CLog
{
private:
	FILE*	m_LogFile;
	int		m_errors;
public:
	HRESULT OpenLogFile(const char* name);								//otevreni souboru
	void	ReportError(int linenumber,const char* format, ...);		//vypis chybove zpravy
	void	ReportWarning(int linenumber, const char* format, ...);		//vypis varovani
	void	TraceCF(const char* format,...);							//vypis zpravy do koznzole a soucasne do souboru
	void	TraceF(const char* format,...);								//vypis zpravy do souboru F=file
	void	TraceC(const char* format,...);								//vypis zpravy do konyole C=concole
	void	ErrorCheck();

	FILE*	GetFile()			{return m_LogFile;}						//vraceni ukazatele na soubor

	CLog();			//konstruktor
	~CLog();		//destruktor
};
